// 80 tracks, 8 sectors, 1024 bytes/sector, interleave 3:1

#include<stdio.h>
#include<strings.h>
#include"floppy.h"

int main(int argc, char **argv) {
int i, err=0, c, h;
char name[12], sector_buffer[1024];

	argc--; argv++;

	if (argc==1) {
		memset(name,0,12);
		memcpy(name,*argv+2,12);
	} else {
		printf("Usage: fzformat diskname\n");
		exit(0);
	}
	
	
	/* format disk */
	for(c=0;c<80;c++) {
		for(h=0;h<2;h++) {
			printf("Formatting track %2d, side %d...\r",c,h);
			fflush(stdout);
			err+=format_track(0,c,h);
		}
	}

	if (err!=0) {
		printf("\nDisk formatting failed.\n");
		exit(-1);
	}
	
	printf("\nInitializing directory...");

	/* "normalize" name */
	for(i=0;i<12;i++) {	
		if (name[i]<' ') {
			for(;i<12;i++) name[i]=' ';
		}
	}

//	sector_buffer=(char *)malloc(1024);
	memset(sector_buffer,0x00,1024);

	/* clear directory */
	
	err+=sector_write(0,1,sector_buffer);
	err+=sector_write(0,2,sector_buffer);
	
	/* write BAM */
	memset(sector_buffer+512,0xff,512);
	memcpy(sector_buffer,name,12);		// disk name
	memcpy(sector_buffer+16,name,12);	// pass work
	sector_buffer[14]=2;
	
	err+=sector_write(0,0,sector_buffer);			
	
	if (err==0) {
		printf("\nFormatting complete.\n");
		exit(0);
	} else {
		printf("\nAn error occured - couldn't format disk.\n");
		exit(-1);
	}
}